//FCUP, VFS 2019/20

predicate sorted(a: array?<int>)
	requires a != null
  reads a
{
    forall i,j :: 0 <= i < j < a.Length  ==> a[i] <= a[j]
}

method BinarySearch(a: array?<int>, value: int) returns (index: int)
   requires a != null && 0 <= a.Length && sorted(a)
   ensures 0 <= index ==> index < a.Length && a[index] == value
   ensures index < 0 ==> forall k :: 0 <= k < a.Length ==> a[k] != value
{
   var low, high := 0, a.Length;
   while low < high
      decreases high -low 
      invariant 0 <= low <= high <= a.Length
      invariant forall i ::
         0 <= i < a.Length && !(low <= i < high) ==> a[i] != value
   {
      var mid := (low + high) / 2;
      if a[mid] < value
      {
         low := mid + 1;
      }
      else if value < a[mid]
      {
         high := mid;
      }
      else
      {
         return mid;
      }
   }
   return -1;
}
method Main() {
   var a := new int[3];
   a[0], a[1],a[2]:=1,2,3;
   var b := BinarySearch(a,4);
   if b > 0  { print "1\n";}
   else {   print "0\n";}
} 