// FCUP, VFS,  2019/20

// Initial recursive definition of n!
function method fact(n: nat) : nat
  decreases n
{
    if n == 0 then 1 else n * fact(n-1)
}

// Iterative calculation of n!
method factIter(n: nat) returns (f : nat)
  ensures f == fact(n)
{
  f := 1;
  var i := 0;
  while i < n 
    decreases n - i
    invariant 0 <= i <= n && f == fact(i)
  {
    i := i + 1;
    f := f * i;
  }
  return f;
}

method Main()
{
  // Statically checked (proved) test cases!    
  assert fact(0) == 1;
  assert fact(1) == 1;
  assert fact(2) == 2;
  assert fact(3) == 6;
 }
