//FCUP,VFS, 2019/20
	// Initial specification, functional style, recursive (exponential time)
function fib(n : nat ) : nat
  decreases n
{
    if n < 2 then n else fib(n - 2) + fib(n - 1)
}


// Iterative method with time complexity O(n), based on dynamic programming.
method computeFib (n : nat) returns (x : nat)
  ensures x == fib(n)
{
    var i := 0;
    x := 0; // fib(0)
    var y := 1; // fib(1)
    while  i < n 
      decreases n-i
      invariant 0 <= i <= n && x == fib(i) && y == fib(i+1)
    {
        x , y := y , x + y;
        i := i + 1;
    }
}

method Main()
{
  assert fib(0) == 0;
  assert fib(1) == 1;
  assert fib(2) == 1;
  assert fib(3) == 2;
  assert fib(4) == 3;
  assert fib(5) == 5;
}
